"use strict";

var HelpButton, React, ReactBootstrap;

React = require("react");

ReactBootstrap = require("react-bootstrap");

HelpButton = React.createClass({
  displayName: "HelpButton",

  openModal: function openModal() {
    var page;
    page = window.open("", "Markdown help", "_blank");
    return page.document.write("<!DOCTYPE html>\n<html>\n  <head>\n    <title>Markdown Help</title>\n    <link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"favicon.ico\" />\n  </head>\n  <body>\n    <pre>\n      Markdown Help\n      -------------\n\n      For detailed and extended information <a href=\"http://daringfireball.net/projects/markdown/syntax\" target=\"_blank\">click here</a>\n\n      # Header 1 #\n      ## Header 2 ##\n      ### Header 3 ###             (Hashes on right are optional)\n      #### Header 4 ####\n      ##### Header 5 #####\n\n      ## Markdown plus h2 with a custom ID ##\n      [Link back to H2](#id-goes-here)\n\n      This is a paragraph, which is text surrounded by whitespace. Paragraphs can be on one\n      line (or many), and can drone on for hours.\n\n      Here is a Markdown link to [Warped](http://warpedvisions.org), and a literal .\n      Now some SimpleLinks, like one to [google] (automagically links to are-you-\n      feeling-lucky), a [wiki: test] link to a Wikipedia page, and a link to\n      [foldoc: CPU]s at foldoc.\n\n      Now some inline markup like _italics_,  **bold**, and code(). Note that underscores in\n      words are ignored in Markdown Extra.\n\n      ![picture alt](/images/photo.jpeg \"Title is optional\")\n\n      &gt; Blockquotes are like quoted text in email replies\n      &gt; And, they can be nested\n\n      * Bullet lists are easy too\n      - Another one\n      + Another one\n\n      1. A numbered list\n      2. Which is numbered\n      3. With periods and a space\n\n      And now some code:\n\n          // Code is just text indented a bit\n          which(is_easy) to_remember();\n\n      ~~~\n\n      // Markdown extra adds un-indented code blocks too\n\n\n      ~~~\n\n      Text with\n      two trailing spaces\n      (on the right)\n      can be used\n      for things like poems\n\n      ### Horizontal rules\n\n      * * * *\n      ****\n      --------------------------\n\n      &lt;div class=\"custom-class\" markdown=\"1\"&gt;\n      This is a div wrapping some Markdown plus.  Without the DIV attribute, it ignores the\n      block.\n      &lt;/div&gt;\n\n      ## Markdown plus tables ##\n\n      | Header | Header | Right  |\n      | ------ | ------ | -----: |\n      |  Cell  |  Cell  |   $10  |\n      |  Cell  |  Cell  |   $20  |\n\n      * Outer pipes on tables are optional\n      * Colon used for alignment (right versus left)\n\n      ## Markdown plus definition lists ##\n\n      Bottled water\n      : $ 1.25\n      : $ 1.55 (Large)\n\n      Milk\n      Pop\n      : $ 1.75\n\n      * Multiple definitions and terms are possible\n      * Definitions can include multiple paragraphs too\n\n      *[ABBR]: Markdown plus abbreviations (produces an &lt;abbr&gt; tag)\n    </pre>\n  </body>\n</html>");
  },
  render: function render() {
    return React.createElement(
      ReactBootstrap.Button,
      { className: "btn-xs btn-gradient", onClick: this.openModal },
      React.createElement(ReactBootstrap.Glyphicon, { glyph: "question-sign" })
    );
  }
});

module.exports = HelpButton;